Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -898,118 +1290,226 @@
 	/**
 	 * Editing files in typo3conf directory (or elsewhere if enabled)
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function typo3conf_edit()	{
-		$EDIT_path = PATH_typo3conf;	// default:
-		if ($this->allowFileEditOutsite_typo3conf_dir && $this->INSTALL['FILE']['EDIT_path'])	{
-			if (t3lib_div::validPathStr($this->INSTALL['FILE']['EDIT_path']) && substr($this->INSTALL['FILE']['EDIT_path'],-1)=='/')	{
+	function typo3conf_edit() {
+			// default:
+		$EDIT_path = PATH_typo3conf;
+		if ($this->allowFileEditOutsite_typo3conf_dir && $this->INSTALL['FILE']['EDIT_path']) {
+			if (t3lib_div::validPathStr($this->INSTALL['FILE']['EDIT_path']) && substr($this->INSTALL['FILE']['EDIT_path'],-1)=='/') {
 				$tmp_path = PATH_site.$this->INSTALL['FILE']['EDIT_path'];
-				if (is_dir($tmp_path))	{
+				if (is_dir($tmp_path)) {
 					$EDIT_path=$tmp_path;
-				} else {debug("'".$tmp_path."' was not dir");}
+				} else {
+					$this->errorMessages[] = '
+						\'' . $tmp_path . '\' was not directory
+					';
+				}
 			} else {
-				debug('BAD DIR_NAME (must be like t3lib/ or media/script/)');
+				$this->errorMessages[] = '
+					Bad directory name (must be like t3lib/ or media/script/)
+				';
 			}
 		}
 
 		$headCode = 'Edit files in '.basename($EDIT_path).'/';
-		$this->contentBeforeTable='';
+		$messages = '';
 
-		if ($this->INSTALL['SAVE_FILE'])	{
+		if ($this->INSTALL['SAVE_FILE']) {
 			$save_to_file = $this->INSTALL['FILE']['name'];
-			if (@is_file($save_to_file))	{
+			if (@is_file($save_to_file)) {
 				$save_to_file_md5 = md5($save_to_file);
-				if (isset($this->INSTALL['FILE'][$save_to_file_md5]) && t3lib_div::isFirstPartOfStr($save_to_file,$EDIT_path.'') && substr($save_to_file,-1)!='~' && !strstr($save_to_file,'_bak'))	{
+				if (isset($this->INSTALL['FILE'][$save_to_file_md5]) && t3lib_div::isFirstPartOfStr($save_to_file,$EDIT_path.'') && substr($save_to_file,-1)!='~' && !strstr($save_to_file,'_bak')) {
 					$this->INSTALL['typo3conf_files'] = $save_to_file;
 					$save_fileContent = $this->INSTALL['FILE'][$save_to_file_md5];
 
-					if ($this->INSTALL['FILE']['win_to_unix_br'])	{
+					if ($this->INSTALL['FILE']['win_to_unix_br']) {
 						$save_fileContent = str_replace(chr(13).chr(10),chr(10),$save_fileContent);
 					}
 
 					$backupFile = $this->getBackupFilename($save_to_file);
-					if ($this->INSTALL['FILE']['backup'])	{
-						if (@is_file($backupFile))	{ unlink($backupFile); }
+					if ($this->INSTALL['FILE']['backup']) {
+						if (@is_file($backupFile)) { unlink($backupFile); }
 						rename($save_to_file,$backupFile);
-						$this->contentBeforeTable.='Backup written to <strong>'.$backupFile.'</strong><br />';
+						$messages .= '
+							Backup written to <strong>' . $backupFile . '</strong>
+							<br />
+						';
 					}
 
 					t3lib_div::writeFile($save_to_file,$save_fileContent);
-					$this->contentBeforeTable.='
-						File saved: <strong>'.$save_to_file.'</strong><br />
-						MD5-sum: '.$this->INSTALL['FILE']['prevMD5'].' (prev)<br />
-						MD5-sum: '.md5($save_fileContent).' (new)<br />
+					$messages .= '
+						File saved: <strong>' . $save_to_file . '</strong>
+						<br />
+						MD5-sum: ' . $this->INSTALL['FILE']['prevMD5'] . ' (prev)
+						<br />
+						MD5-sum: ' . md5($save_fileContent) . ' (new)
+						<br />
 					';
 				}
 			}
 		}
 
 			// Filelist:
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'Typo3ConfEdit.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Get the subpart for the files
+		$filesSubpart = $this->contentObject->getSubpart($template, '###FILES###');
+		$files = array();
+
 		$typo3conf_files = t3lib_div::getFilesInDir($EDIT_path,'',1,1);
-		reset($typo3conf_files);
-		$lines=array();
 		$fileFound = 0;
-		while(list($k,$file)=each($typo3conf_files))	{
+
+
+		foreach ($typo3conf_files as $k => $file) {
 				// Delete temp_CACHED files if option is set
-			if ( $this->INSTALL['delTempCached'] && preg_match('|/temp_CACHED_[a-z0-9_]+\.php|', $file))	{
+			if ( $this->INSTALL['delTempCached'] && preg_match('|/temp_CACHED_[a-z0-9_]+\.php|', $file)) {
 				unlink($file);
 				continue;
 			}
-			if ($this->INSTALL['typo3conf_files'] && !strcmp($this->INSTALL['typo3conf_files'],$file))	{
-				$wrap=array('<strong><span style="color:navy;">','</span></strong>');
+			if ($this->INSTALL['typo3conf_files'] && !strcmp($this->INSTALL['typo3conf_files'],$file)) {
 				$fileFound = 1;
-			} else {$wrap=array();}
-			$lines[]='<tr><td nowrap="nowrap"><a href="'.$this->action.'&TYPO3_INSTALL[typo3conf_files]='.rawurlencode($file).($this->allowFileEditOutsite_typo3conf_dir?'&TYPO3_INSTALL[FILE][EDIT_path]='.rawurlencode($this->INSTALL['FILE']['EDIT_path']):"").'">'.$this->fw($wrap[0].basename($file).$wrap[1].'&nbsp;&nbsp;&nbsp;').'</a></td><td>'.$this->fw(t3lib_div::formatSize(filesize($file))).'</td></tr>';
+			}
+				// Define the markers content for the files subpart
+			$filesMarkers = array(
+				'editUrl' => $this->action . '&amp;TYPO3_INSTALL[typo3conf_files]=' . rawurlencode($file) . ($this->allowFileEditOutsite_typo3conf_dir ? '&amp;TYPO3_INSTALL[FILE][EDIT_path]=' . rawurlencode($this->INSTALL['FILE']['EDIT_path']) : '') . '#confEditFileList',
+				'fileName' => basename($file),
+				'fileSize' => t3lib_div::formatSize(filesize($file)),
+				'class' => $this->INSTALL['typo3conf_files'] && !strcmp($this->INSTALL['typo3conf_files'], $file) ? 'class="act"' : ''
+			);
+				// Fill the markers in the subpart
+			$files[] = $this->contentObject->substituteMarkerArray(
+				$filesSubpart,
+				$filesMarkers,
+				'###|###',
+				1,
+				1
+			);
 		}
-		$fileList='<table border="0" cellpadding="0" cellspacing="0">'.implode('',$lines).'</table>';
-		$fileList.='<br />('.$EDIT_path.')';
 
-		if ($this->allowFileEditOutsite_typo3conf_dir)	{
-			$fileList.='<br /><form action="'.$this->action.'" method="post">
-			'.PATH_site.'<input type="text" name="TYPO3_INSTALL[FILE][EDIT_path]" value="'.$this->INSTALL['FILE']['EDIT_path'].'"><input type="submit" name="" value="Set">
-			</form>';
-		}
+		if ($fileFound && @is_file($this->INSTALL['typo3conf_files'])) {
 
-			// create link for deleting temp_CACHED files
-		$fileList .= '<br /><br /><a href="'.$this->action.'&TYPO3_INSTALL[delTempCached]=1">Delete temp_CACHED* files</a>';
-
-		if ($fileFound && @is_file($this->INSTALL['typo3conf_files']))	{
-
 			$backupFile = $this->getBackupFilename($this->INSTALL['typo3conf_files']);
 			$fileContent = t3lib_div::getUrl($this->INSTALL['typo3conf_files']);
-			$this->contentBeforeTable.= '<div class="editFile"><form action="'.$this->action.'" method="post">'.(substr($this->INSTALL['typo3conf_files'],-1)!='~' && !strstr($this->INSTALL['typo3conf_files'],'_bak') ? '
-				<input type="submit" name="TYPO3_INSTALL[SAVE_FILE]" value="Save file">&nbsp;' : '').'
-				<input type="submit" name="_close" value="Close">
-				<br />File: '.$this->INSTALL['typo3conf_files'].'
-				<br />MD5-sum: '.md5($fileContent).'
-				<br />
+				// Get the subpart to edit the files
+			$fileEditTemplate = $this->contentObject->getSubpart($template, '###FILEEDIT###');
+			$allowFileEditOutsideTypo3ConfDirSubPart = '';
 
-				<input type="hidden" name="TYPO3_INSTALL[FILE][name]" value="'.$this->INSTALL['typo3conf_files'].'">
-				'.($this->allowFileEditOutsite_typo3conf_dir?'<input type="hidden" name="TYPO3_INSTALL[FILE][EDIT_path]" value="'.$this->INSTALL['FILE']['EDIT_path'].'">':'').'
-				<input type="hidden" name="TYPO3_INSTALL[FILE][prevMD5]" value="'.md5($fileContent).'">
-				<textarea rows="30" name="TYPO3_INSTALL[FILE]['.md5($this->INSTALL['typo3conf_files']).']" wrap="off"'.$this->formWidthText(48,'width:98%;height:80%','off').' class="fixed-font enable-tab">'.t3lib_div::formatForTextarea($fileContent).'</textarea><br />
-				<input type="checkbox" name="TYPO3_INSTALL[FILE][win_to_unix_br]" id="win_to_unix_br" value="1"'.(TYPO3_OS=='WIN'?'':' checked="checked"').'> <label for="win_to_unix_br">Convert Windows linebreaks (13-10) to Unix (10)</label><br />
-				<input type="checkbox" name="TYPO3_INSTALL[FILE][backup]" id="backup" value="1"'.(@is_file($backupFile) ? ' checked="checked"' : '').'> <label for="backup">Make backup copy (rename to '.basename($backupFile).')</label><br />
-				'.
-			'</form></div>';
+			if (substr($this->INSTALL['typo3conf_files'], -1) != '~' && !strstr($this->INSTALL['typo3conf_files'], '_bak')) {
+					// Get the subpart to show the save button
+				$showSaveButtonSubPart = $this->contentObject->getSubpart($fileEditTemplate, '###SHOWSAVEBUTTON###');
+			}
+
+			if ($this->allowFileEditOutsite_typo3conf_dir) {
+					// Get the subpart to show if files are allowed outside the directory typo3conf
+				$allowFileEditOutsideTypo3ConfDirSubPart = $this->contentObject->getSubpart($fileEditTemplate, '###ALLOWFILEEDITOUTSIDETYPO3CONFDIR###');
+			}
+				// Substitute the subpart for the save button
+			$fileEditContent = $this->contentObject->substituteSubpart(
+				$fileEditTemplate,
+				'###SHOWSAVEBUTTON###',
+				$showSaveButtonSubPart
+			);
+				// Substitute the subpart to show if files are allowed outside the directory typo3conf
+			$fileEditContent = $this->contentObject->substituteSubpart(
+				$fileEditContent,
+				'###ALLOWFILEEDITOUTSIDETYPO3CONFDIR###',
+				$allowFileEditOutsideTypo3ConfDirSubPart
+			);
+				// Define the markers content for subpart to edit the files
+			$fileEditMarkers = array(
+				'messages' => !empty($messages) ? '<p class="typo3-message message-warning">' . $messages . '</p>' : '',
+				'action' => $this->action . '#fileEditHeader',
+				'saveFile' => 'Save file',
+				'close' => 'Close',
+				'llEditing' => 'Editing file:',
+				'file' => $this->INSTALL['typo3conf_files'],
+				'md5Sum' => 'MD5-sum: ' . md5($fileContent),
+				'fileName' => $this->INSTALL['typo3conf_files'],
+				'fileEditPath' => $this->INSTALL['FILE']['EDIT_path'],
+				'filePreviousMd5' => md5($fileContent),
+				'fileMd5' => md5($this->INSTALL['typo3conf_files']),
+				'fileContent' => t3lib_div::formatForTextarea($fileContent),
+				'winToUnixBrChecked' => TYPO3_OS == 'WIN' ? '' : 'checked="checked"',
+				'winToUnixBr' => 'Convert Windows linebreaks (13-10) to Unix (10)',
+				'backupChecked' => @is_file($backupFile) ? 'checked="checked"' : '',
+				'backup' => 'Make backup copy (rename to ' . basename($backupFile) . ')'
+			);
+				// Fill the markers in the subpart to edit the files
+			$fileEditContent = $this->contentObject->substituteMarkerArray(
+				$fileEditContent,
+				$fileEditMarkers,
+				'###|###',
+				1,
+				1
+			);
 		}
 
-		if ($this->contentBeforeTable)	{
-			$this->contentBeforeTable = $this->fw($this->contentBeforeTable);
+		if ($this->allowFileEditOutsite_typo3conf_dir) {
+				// Get the subpart to show if files are allowed outside the directory typo3conf
+			$allowFileEditOutsideTypo3ConfDirSubPart = $this->contentObject->getSubpart($template, '###ALLOWFILEEDITOUTSIDETYPO3CONFDIR###');
+				// Define the markers content
+			$allowFileEditOutsideTypo3ConfDirMarkers = array(
+				'action' => $this->action,
+				'pathSite' => PATH_site,
+				'editPath' => $this->INSTALL['FILE']['EDIT_path'],
+				'set' => 'Set'
+			);
+				// Fill the markers in the subpart
+			$allowFileEditOutsideTypo3ConfDirSubPart = $this->contentObject->substituteMarkerArray(
+				$allowFileEditOutsideTypo3ConfDirSubPart,
+				$allowFileEditOutsideTypo3ConfDirMarkers,
+				'###|###',
+				1,
+				1
+			);
 		}
-
-		$this->message($headCode,'Files in folder',$fileList);
-
+			// Substitute the subpart to edit the file
+		$fileListContent = $this->contentObject->substituteSubpart(
+			$template,
+			'###FILEEDIT###',
+			$fileEditContent
+		);
+			// Substitute the subpart when files can be edited outside typo3conf directory
+		$fileListContent = $this->contentObject->substituteSubpart(
+			$fileListContent,
+			'###ALLOWFILEEDITOUTSIDETYPO3CONFDIR###',
+			$allowFileEditOutsideTypo3ConfDirSubPart
+		);
+			// Substitute the subpart for the files
+		$fileListContent = $this->contentObject->substituteSubpart(
+			$fileListContent,
+			'###FILES###',
+			implode(chr(10), $files)
+		);
+			// Define the markers content
+		$fileListMarkers = array(
+			'editPath' => '(' . $EDIT_path . ')',
+			'deleteTempCachedUrl' => $this->action . '&amp;TYPO3_INSTALL[delTempCached]=1',
+			'deleteTempCached' => 'Delete temp_CACHED* files'
+		);
+			// Fill the markers
+		$fileListContent = $this->contentObject->substituteMarkerArray(
+			$fileListContent,
+			$fileListMarkers,
+			'###|###',
+			1,
+			1
+		);
+			// Add the content to the message array
+		$this->message($headCode, 'Files in folder', $fileListContent);
+			// Output the page
 		$this->output($this->outputWrapper($this->printAll()));
 	}
 
 	/**
 	 * Outputs system information
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function phpinformation()	{
+	function phpinformation() {
 		$headCode = 'PHP information';
 
 		$sVar = t3lib_div::getIndpEnv('_ARRAY');
@@ -1030,49 +1530,72 @@
 		$sVar['OTHER: memory_limit']=ini_get('memory_limit');
 
 		$gE_keys = explode(',','SERVER_PORT,SERVER_SOFTWARE,GATEWAY_INTERFACE,SCRIPT_NAME,PATH_TRANSLATED');
-		while(list(,$k)=each($gE_keys))	{
+		foreach ($gE_keys as $k) {
 			$sVar['SERVER: '.$k]=$_SERVER[$k];
 		}
 
 		$gE_keys = explode(',','image_processing,gdlib,gdlib_png,gdlib_2,im,im_path,im_path_lzw,im_version_5,im_negate_mask,im_imvMaskState,im_combine_filename');
-		while(list(,$k)=each($gE_keys))	{
+
+		foreach ($gE_keys as $k) {
 			$sVar['T3CV_GFX: '.$k]=$GLOBALS['TYPO3_CONF_VARS']['GFX'][$k];
 		}
 
-		$debugInfo=array();
-		$debugInfo[]='### DEBUG SYSTEM INFORMATION - START ###';
-		reset($sVar);
-		while(list($kkk,$vvv)=each($sVar))	{
+		$debugInfo = array(
+				'### DEBUG SYSTEM INFORMATION - START ###'
+			);
+		foreach ($sVar as $kkk => $vvv) {
 			$debugInfo[]=str_pad(substr($kkk,0,20),20).': '.$vvv;
 		}
 		$debugInfo[]='### DEBUG SYSTEM INFORMATION - END ###';
-
-		$buf=$this->messageFunc_nl2br;
-		$this->messageFunc_nl2br=0;
-		$this->message($headCode,'DEBUG information','Please copy/paste the information from this text field into an email or bug-report as "Debug System Information" whenever you wish to get support or report problems. This information helps others to check if your system has some obvious misconfiguration and you\'ll get your help faster!<br />
-		<form action=""><textarea rows="10" '.$this->formWidthText(80,'width:100%; height:500px;','off').' wrap="off" class="fixed-font">'.t3lib_div::formatForTextarea(implode(chr(10),$debugInfo)).'</textarea></form>');
-		$this->messageFunc_nl2br=$buf;
-
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'PhpInformation.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Define the markers content
+		$markers = array(
+			'explanation' => 'Please copy/paste the information from this text field into an email or bug-report as "Debug System Information" whenever you wish to get support or report problems. This information helps others to check if your system has some obvious misconfiguration and you\'ll get your help faster!',
+			'debugInfo' => t3lib_div::formatForTextarea(implode(chr(10), $debugInfo))
+		);
+			// Fill the markers
+		$content = $this->contentObject->substituteMarkerArray(
+			$template,
+			$markers,
+			'###|###',
+			1,
+			1
+		);
+			// Add the content to the message array
+		$this->message($headCode, 'DEBUG information', $content);
+			// Start with various server information
 		$getEnvArray = array();
 		$gE_keys = explode(',','QUERY_STRING,HTTP_ACCEPT,HTTP_ACCEPT_ENCODING,HTTP_ACCEPT_LANGUAGE,HTTP_CONNECTION,HTTP_COOKIE,HTTP_HOST,HTTP_USER_AGENT,REMOTE_ADDR,REMOTE_HOST,REMOTE_PORT,SERVER_ADDR,SERVER_ADMIN,SERVER_NAME,SERVER_PORT,SERVER_SIGNATURE,SERVER_SOFTWARE,GATEWAY_INTERFACE,SERVER_PROTOCOL,REQUEST_METHOD,SCRIPT_NAME,PATH_TRANSLATED,HTTP_REFERER,PATH_INFO');
-		while(list(,$k)=each($gE_keys))	{
+		foreach ($gE_keys as $k) {
 			$getEnvArray[$k] = getenv($k);
 		}
-		$this->message($headCode,'t3lib_div::getIndpEnv()',t3lib_div::view_array(t3lib_div::getIndpEnv('_ARRAY')));
-		$this->message($headCode,'getenv()',t3lib_div::view_array($getEnvArray));
-		$this->message($headCode,'_ENV',t3lib_div::view_array($_ENV));
-		$this->message($headCode,'_SERVER',t3lib_div::view_array($_SERVER));
-		$this->message($headCode,'_COOKIE',t3lib_div::view_array($_COOKIE));
-		$this->message($headCode,'_GET',t3lib_div::view_array($_GET));
-
+		$this->message($headCode, 't3lib_div::getIndpEnv()', $this->viewArray(t3lib_div::getIndpEnv('_ARRAY')));
+		$this->message($headCode, 'getenv()', $this->viewArray($getEnvArray));
+		$this->message($headCode, '_ENV', $this->viewArray($_ENV));
+		$this->message($headCode, '_SERVER', $this->viewArray($_SERVER));
+		$this->message($headCode, '_COOKIE', $this->viewArray($_COOKIE));
+		$this->message($headCode, '_GET', $this->viewArray($_GET));
+			// Start with the phpinfo() part
 		ob_start();
 		phpinfo();
 		$contents = explode('<body>',ob_get_contents());
 		ob_end_clean();
 		$contents = explode('</body>',$contents[1]);
-
-		$this->message($headCode,'phpinfo()','<div class="phpinfo">' . $contents[0] . '</div>');
-
+			// Do code cleaning: phpinfo() is not XHTML1.1 compliant
+		$phpinfo = str_replace('<font', '<span', $contents[0]);
+		$phpinfo = str_replace('</font', '</span', $phpinfo);
+		$phpinfo = str_replace('<img border="0"', '<img', $phpinfo);
+		$phpinfo = str_replace('<a name=', '<a id=', $phpinfo);
+			// Add phpinfo() to the message array
+		$this->message($headCode, 'phpinfo()', '
+			<div class="phpinfo">
+				' . $phpinfo . '
+			</div>
+		');
+			// Output the page
 		$this->output($this->outputWrapper($this->printAll()));
 	}
 
@@ -1097,22 +1620,36 @@
 	/**
 	 * Provides a tool for deleting temporary files located in typo3temp/
 	 *
-	 * @return	string		HTML output
+	 * @return void
 	 */
-	function typo3TempManager()	{
+	function typo3TempManager() {
 		$headCode = 'typo3temp/ directory';
-		$this->message($headCode,'What is it?','
-		TYPO3 uses this directory for temporary files, mainly processed and cached images.
-		The filenames are very cryptic; They are unique representations of the file properties made by md5-hashing a serialized array with information.
-		Anyway this directory may contain many thousand files and a lot of them may be of no use anymore.
-
-		With this test you can delete the files in this folder. When you do that, you should also clear the cache database tables afterwards.
+		$this->message($headCode, 'What is it?', '
+			<p>
+				TYPO3 uses this directory for temporary files, mainly processed
+				and cached images.
+				<br />
+				The filenames are very cryptic; They are unique representations
+				of the file properties made by md5-hashing a serialized array
+				with information.
+				<br />
+				Anyway this directory may contain many thousand files and a lot
+				of them may be of no use anymore.
+			</p>
+			<p>
+				With this test you can delete the files in this folder. When you
+				do that, you should also clear the cache database tables
+				afterwards.
+			</p>
 		');
 
-		if (!$this->config_array['dir_typo3temp'])	{
-			$this->message('typo3temp/ directory','typo3temp/ not writable!',"
-				You must make typo3temp/ write enabled before you can proceed with this test.
-			",2);
+		if (!$this->config_array['dir_typo3temp']) {
+			$this->message('typo3temp/ directory', 'typo3temp/ not writable!', '
+				<p>
+					You must make typo3temp/ write enabled before you can
+					proceed with this test.
+				</p>
+			', 2);
 			$this->output($this->outputWrapper($this->printAll()));
 			return;
 		}
@@ -1127,14 +1664,14 @@
 		if (strlen($subdir) && !preg_match('/^[[:alnum:]_]+\/$/',$subdir))	die('subdir "'.$subdir.'" was not allowed!');
 		$action = $this->INSTALL['typo3temp_action'];
 		$d = @dir($this->typo3temp_path.$subdir);
-		if (is_object($d))	{
+		if (is_object($d)) {
 			while($entry=$d->read()) {
 				$theFile = $this->typo3temp_path.$subdir.$entry;
-				if (@is_file($theFile))	{
+				if (@is_file($theFile)) {
 					$ok = 0;
 					$fileCounter++;
-					if ($tt)	{
-						if (t3lib_div::testInt($tt))	{
+					if ($tt) {
+						if (t3lib_div::testInt($tt)) {
 							if (filesize($theFile) > $tt*1024)	$ok=1;
 						} else {
 							if (fileatime($theFile) < $GLOBALS['EXEC_TIME'] - (intval($tmap[$tt]) * 60 * 60 * 24)) {
@@ -1144,10 +1681,11 @@
 					} else {
 						$ok = 1;
 					}
-					if ($ok)	{
+					if ($ok) {
 						$hashPart=substr(basename($theFile),-14,10);
-						if (!preg_match('/[^a-f0-9]/',$hashPart) || substr($theFile,-6)==='.cache' || substr($theFile,-4)==='.tbl' || substr(basename($theFile),0,8)==='install_')	{		// This is a kind of check that the file being deleted has a 10 char hash in it
-							if ($action && $deleteCounter<$action)	{
+							// This is a kind of check that the file being deleted has a 10 char hash in it
+						if (!preg_match('/[^a-f0-9]/',$hashPart) || substr($theFile,-6)==='.cache' || substr($theFile,-4)==='.tbl' || substr(basename($theFile),0,8)==='install_') {
+							if ($action && $deleteCounter<$action) {
 								$deleteCounter++;
 								unlink($theFile);
 							} else {
@@ -1163,10 +1701,10 @@
 			// Find sub-dirs:
 		$subdirRegistry = array(''=>'');
 		$d = @dir($this->typo3temp_path);
-		if (is_object($d))	{
+		if (is_object($d)) {
 			while($entry=$d->read()) {
 				$theFile = $entry;
-				if (@is_dir($this->typo3temp_path.$theFile) && $theFile!='..' && $theFile!='.')	{
+				if (@is_dir($this->typo3temp_path.$theFile) && $theFile!='..' && $theFile!='.') {
 					$subdirRegistry[$theFile.'/'] = $theFile.'/ (Files: '.count(t3lib_div::getFilesInDir($this->typo3temp_path.$theFile)).')';
 				}
 			}
@@ -1188,49 +1726,122 @@
 			'500' => 'Delete 500',
 			'1000' => 'Delete 1000'
 		);
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'Typo3TempManager.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Get the subpart for 'Delete files by condition' dropdown
+		$deleteOptionsSubpart = $this->contentObject->getSubpart($template, '###DELETEOPTIONS###');
+		$deleteOptions = array();
 
-		$content='<select name="TYPO3_INSTALL[typo3temp_delete]">'.$this->getSelectorOptions($deleteType,$tt).'</select>
-		<br />
-Number of files at a time:
-		<select name="TYPO3_INSTALL[typo3temp_action]">'.$this->getSelectorOptions($actionType).'</select>
+		foreach ($deleteType as $deleteKey => $deleteValue) {
+				// Define the markers content
+			$deleteMarkers = array(
+				'value' => htmlspecialchars($deleteKey),
+				'selected' => !strcmp($deleteKey, $tt) ? 'selected="selected"' : '',
+				'data' => htmlspecialchars($deleteValue)
+			);
+				// Fill the markers in the subpart
+			$deleteOptions[] = $this->contentObject->substituteMarkerArray(
+				$deleteOptionsSubpart,
+				$deleteMarkers,
+				'###|###',
+				1,
+				1
+			);
+		}
+			// Substitute the subpart for 'Delete files by condition' dropdown
+		$content = $this->contentObject->substituteSubpart(
+			$template,
+			'###DELETEOPTIONS###',
+			implode(chr(10), $deleteOptions)
+		);
+			// Get the subpart for 'Number of files at a time' dropdown
+		$actionOptionsSubpart = $this->contentObject->getSubpart($template, '###ACTIONOPTIONS###');
+		$actionOptions = array();
 
-From sub-directory:
-		<select name="TYPO3_INSTALL[typo3temp_subdir]">'.$this->getSelectorOptions($subdirRegistry, $this->INSTALL['typo3temp_subdir']).'</select>
-		';
+		foreach ($actionType as $actionKey => $actionValue) {
+				// Define the markers content
+			$actionMarkers = array(
+				'value' => htmlspecialchars($actionKey),
+				'data' => htmlspecialchars($actionValue)
+			);
+				// Fill the markers in the subpart
+			$actionOptions[] = $this->contentObject->substituteMarkerArray(
+				$actionOptionsSubpart,
+				$actionMarkers,
+				'###|###',
+				1,
+				1
+			);
+		}
+			// Substitute the subpart for 'Number of files at a time' dropdown
+		$content = $this->contentObject->substituteSubpart(
+			$content,
+			'###ACTIONOPTIONS###',
+			implode(chr(10), $actionOptions)
+		);
+			// Get the subpart for 'From sub-directory' dropdown
+		$subDirectoryOptionsSubpart = $this->contentObject->getSubpart($template, '###SUBDIRECTORYOPTIONS###');
+		$subDirectoryOptions = array();
 
-		$form = '<form action="'.$this->action.'" method="post">'.$content.'
-
-		<input type="submit" value="Execute">
-		</form>
-		This tool will delete files only if the last 10 characters before the extension (3 chars+\'.\') are hexadecimal valid ciphers, which are lowercase a-f and 0-9.';
-
-		$this->message($headCode,'Statistics','
-		Number of temporary files: <strong>'.($fileCounter-$deleteCounter)."</strong>
-		Number matching '".htmlspecialchars($deleteType[$tt])."': <strong>".$criteriaMatch.'</strong>
-		Number deleted: <strong>'.$deleteCounter.'</strong>
-		<br />
-		'.$form,1);
-
+		foreach ($subdirRegistry as $subDirectoryKey => $subDirectoryValue) {
+				// Define the markers content
+			$subDirectoryMarkers = array(
+				'value' => htmlspecialchars($subDirectoryKey),
+				'selected' => !strcmp($subDirectoryKey, $this->INSTALL['typo3temp_subdir']) ? 'selected="selected"' : '',
+				'data' => htmlspecialchars($subDirectoryValue)
+			);
+				// Fill the markers in the subpart
+			$subDirectoryOptions[] = $this->contentObject->substituteMarkerArray(
+				$subDirectoryOptionsSubpart,
+				$subDirectoryMarkers,
+				'###|###',
+				1,
+				1
+			);
+		}
+			// Substitute the subpart for 'From sub-directory' dropdown
+		$content = $this->contentObject->substituteSubpart(
+			$content,
+			'###SUBDIRECTORYOPTIONS###',
+			implode(chr(10), $subDirectoryOptions)
+		);
+			// Define the markers content
+		$markers = array(
+			'numberTemporary' => 'Number of temporary files:',
+			'numberMatching' => 'Number matching:',
+			'numberDeleted' => 'Number deleted:',
+			'temporary' => ($fileCounter - $deleteCounter),
+			'matching' => $criteriaMatch,
+			'deleteType' => '<span>' . htmlspecialchars($deleteType[$tt]) . '</span>',
+			'deleted' => $deleteCounter,
+			'deleteCondition' => 'Delete files by condition',
+			'numberFiles' => 'Number of files at a time:',
+			'fromSubdirectory' => 'From sub-directory:',
+			'execute' => 'Execute',
+			'explanation' => '
+				<p>
+					This tool will delete files only if the last 10 characters
+					before the extension (3 chars+\'.\') are hexadecimal valid
+					ciphers, which are lowercase a-f and 0-9.
+				</p>
+			'
+		);
+			// Fill the markers
+		$content = $this->contentObject->substituteMarkerArray(
+			$content,
+			$markers,
+			'###|###',
+			1,
+			1
+		);
+			// Add the content to the message array
+		$this->message($headCode, 'Statistics', $content, 1);
+			// Output the page
 		$this->output($this->outputWrapper($this->printAll()));
 	}
 
-	/**
-	 * [Describe function...]
-	 *
-	 * @param	[type]		$deleteType: ...
-	 * @param	[type]		$tt: ...
-	 * @return	[type]		...
-	 */
-	function getSelectorOptions($deleteType,$tt='')	{
-		$out='';
-		if (is_array($deleteType))	{
-			reset($deleteType);
-			while(list($v,$l)=each($deleteType))	{
-				$out.='<option value="'.htmlspecialchars($v).'"'.(!strcmp($v,$tt)?' selected="selected"':'').'>'.htmlspecialchars($l).'</option>';
-			}
-		}
-		return $out;
-	}
 
 
 
@@ -1239,7 +1850,6 @@
 
 
 
-
 	/*******************************
 	 *
 	 * cleanup manager
@@ -1249,19 +1859,30 @@
 	/**
 	 * Provides a tool cleaning up various tables in the database
 	 *
-	 * @return	string		HTML output
-	 * @author	Robert Lemke <rl@robertlemke.de>
-	 * @todo	Add more functionality ...
+	 * @return void
+	 * @author Robert Lemke <rl@robertlemke.de>
+	 * @todo Add more functionality ...
 	 */
-	function cleanupManager()	{
+	function cleanupManager() {
 		$headCode = 'Clean up database';
-		$this->message($headCode,'What is it?','
-		This function will become a general clean up manager for various tables used by TYPO3. By now you can only empty the cache which is used for storing image sizes of all pictures used in TYPO3.
-
-		<strong>Clear cached image sizes</strong>
-		Clears the cache used for memorizing sizes of all images used in your website. This information is cached in order to gain performance and will be stored each time a new image is being displayed in the frontend.
-
-		You should <em>Clear All Cache</em> in the backend after clearing this cache.
+		$this->message($headCode, 'What is it?', '
+			<p>
+				This function will become a general clean up manager for various
+				tables used by TYPO3. By now you can only empty the cache which
+				is used for storing image sizes of all pictures used in TYPO3.
+			</p>
+			<p>
+				<strong>Clear cached image sizes</strong>
+				<br />
+				Clears the cache used for memorizing sizes of all images used in
+				your website. This information is cached in order to gain
+				performance and will be stored each time a new image is being
+				displayed in the frontend.
+			</p>
+			<p>
+				You should <em>Clear All Cache</em> in the backend after
+				clearing this cache.
+			</p>
 		');
 
 		$tables = $this->getListOfTables();
